diff -cr postgresql-snapshot-030203/src/backend/access/transam/slru.c postgresql-win32-mha/src/backend/access/transam/slru.c
*** postgresql-snapshot-030203/src/backend/access/transam/slru.c	Wed Jan 28 22:02:39 2004
--- postgresql-win32-mha/src/backend/access/transam/slru.c	Sun Feb  8 22:04:55 2004
***************
*** 916,921 ****
--- 916,927 ----
  		}
  		errno = 0;
  	}
+ #ifdef WIN32
+ 	/* This fix is in mingw cvs (runtime/mingwex/dirent.c rev 1.4), but
+ 	   not in released version */
+ 	if (GetLastError() == ERROR_NO_MORE_FILES)
+ 		errno = 0;
+ #endif
  	if (errno)
  		ereport(ERROR,
  				(errcode_for_file_access(),
diff -cr postgresql-snapshot-030203/src/backend/access/transam/xlog.c postgresql-win32-mha/src/backend/access/transam/xlog.c
*** postgresql-snapshot-030203/src/backend/access/transam/xlog.c	Mon Jan 26 23:35:31 2004
--- postgresql-win32-mha/src/backend/access/transam/xlog.c	Sun Feb  8 22:04:41 2004
***************
*** 1677,1682 ****
--- 1677,1688 ----
  		}
  		errno = 0;
  	}
+ #ifdef WIN32
+ 	/* This fix is in mingw cvs (runtime/mingwex/dirent.c rev 1.4), but
+ 	   not in released version */
+ 	if (GetLastError() == ERROR_NO_MORE_FILES)
+ 		errno = 0;
+ #endif
  	if (errno)
  		ereport(PANIC,
  				(errcode_for_file_access(),
diff -cr postgresql-snapshot-030203/src/bin/pg_resetxlog/pg_resetxlog.c postgresql-win32-mha/src/bin/pg_resetxlog/pg_resetxlog.c
*** postgresql-snapshot-030203/src/bin/pg_resetxlog/pg_resetxlog.c	Sat Nov 29 20:52:06 2003
--- postgresql-win32-mha/src/bin/pg_resetxlog/pg_resetxlog.c	Sun Feb  8 22:06:40 2004
***************
*** 579,584 ****
--- 579,590 ----
  		}
  		errno = 0;
  	}
+ #ifdef WIN32
+ 	/* This fix is in mingw cvs (runtime/mingwex/dirent.c rev 1.4), but
+ 	   not in released version */
+ 	if (GetLastError() == ERROR_NO_MORE_FILES)
+ 		errno = 0;
+ #endif
  
  	if (errno)
  	{
